#include<bits/stdc++.h>
#define ll long long
using namespace std;
ll T,N,M,X,mod,niz[100005];
ll nzd(ll a,ll b){
    if(a<b)
        swap(b,a);
    if(a%b==0)
        return b;
    return nzd(b,a%b);
}
bool moze;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>T;
    while(T--){
        cin>>N>>M;
        for(int i=1;i<=N;i++)
            cin>>niz[i];
        sort(niz+1,niz+1+N);
        X=niz[2]-niz[1];
        for(int i=3;i<=N;i++)
            X=nzd(X,niz[i]-niz[i-1]);
        mod=niz[1]%X;
        moze=true;
        for(int i=1;i<=N;i++){
            cin>>niz[2];
            if(niz[2]%X==mod)
                moze=false;
        }
        if(moze)
            cout<<1<<endl;
        else cout<<0<<endl;
    }
    return 0;
}